module GHCup.Logger where


import           System.Console.Pretty
import           System.IO
import           Control.Monad.Logger

import qualified Data.ByteString as B


myLoggerT :: (B.ByteString -> IO ()) -> LoggingT m a -> m a
myLoggerT outter loggingt = runLoggingT loggingt mylogger
 where
  mylogger :: Loc -> LogSource -> LogLevel -> LogStr -> IO ()
  mylogger _ _ level str' = do
    let l = case level of
          LevelDebug   -> toLogStr (style Bold $ color Blue   "[ Debug ]")
          LevelInfo    -> toLogStr (style Bold $ color Green  "[ Info  ]")
          LevelWarn    -> toLogStr (style Bold $ color Yellow "[ Warn  ]")
          LevelError   -> toLogStr (style Bold $ color Red    "[ Error ]")
          LevelOther t -> toLogStr "[ " <> toLogStr t <> toLogStr " ]"
    let out = fromLogStr (l <>  toLogStr " " <> str' <> toLogStr "\n")
    outter out

myLoggerTStdout :: LoggingT m a -> m a
myLoggerTStdout = myLoggerT (B.hPut stdout)

myLoggerTStderr :: LoggingT m a -> m a
myLoggerTStderr = myLoggerT (B.hPut stderr)

